<script>
  export let route
  export let title

  import groups from '../stores/groups'

  import LoadingBox from '../components/LoadingBox'
  import Error from '../components/Error'

  import { getGroup } from '../api/groups'
  import localForage from 'localforage'

  import offline from '../stores/offline'
  import { setToast } from '../stores/toast'

  import { ArrowForward } from '../assets/icons'

  let groupPromise
  let joiningPromise
  $: id = parseInt(route.matches[1])
  $: secret = route.matches[2]
  $: refresh(id, secret)

  function refresh() {
    groupPromise = getGroup(id, secret).then(resp => {
      $title = `Unirse a ${resp.group.name}`
      return resp
    })
  }

  function join() {
    return (joiningPromise = (async () => {
      let groups = (await localForage.getItem('groups')) || []
      if (groups.find(group => group.id === id)) {
        setToast('¡Ya estás en este grupo! :)')
      } else {
        await localForage.setItem('groups', [...groups, { id, secret }])
      }
      location.hash = `#/groups/${id}`
    })())
  }
</script>

<div class="max-w-xl mx-auto my-4 px-4 text-center">
  {#await groupPromise}
    <LoadingBox />
  {:then resp}
    <header class="my-8">
      <h1 class="text-3xl font-bold mb-2 leading-snug">
        Te invitaron a {resp.group.name}.
      </h1>
      <h3 class="text-lg">
        <span>
          Manejador de Tareas es una aplicación para manejar tareas (¡duh!) en
          grupo.
        </span>
        <a
          class="link"
          target="_blank"
          rel="noopener"
          href="https://tareas.nulo.in"
        >
          Más información
        </a>
      </h3>
    </header>
    <button
      class="btn btn-blue shadow text-xl"
      disabled={joiningPromise || $offline}
      on:click={join}
    >
      Unirse al grupo
      <ArrowForward props={{ class: 's-8 ml-2' }} />
    </button>
  {:catch error}
    {#if error === 'forbidden'}
      <h1 class="text-xl font-bold">La url de invitación es invalida.</h1>
      <p>Fijate que se haya mandado o copiado bien.</p>
    {:else}
      <Error {error} />
      <button class="btn btn-outlined my-2" on:click={refresh}>
        Reintentar
      </button>
    {/if}
  {/await}
</div>
